

Public Class CustomTreeView
    Inherits TreeView
    Private Const WM_VSCROLL As Integer = &H115
    Private Const WM_HSCROLL As Integer = &H114


    Protected Overrides Sub WndProc(ByRef m As System.Windows.Forms.Message)
        Dim ItemX As CustomTreeNode

        Select Case m.Msg
            Case WM_HSCROLL, WM_VSCROLL
                MyBase.WndProc(m)

                For Each ItemX In Me.Nodes
                    ItemX.Refresh()
                Next

            Case Else
                MyBase.WndProc(m)
        End Select
    End Sub

    Private Sub myTreeView_AfterExpand(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles MyBase.AfterExpand
        Dim ItemX As CustomTreeNode

        For Each ItemX In Me.Nodes
            ItemX.Refresh()
        Next
    End Sub

    Private Sub myTreeView_AfterCollapse(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles MyBase.AfterCollapse
        Dim ItemX As CustomTreeNode

        For Each ItemX In Me.Nodes
            ItemX.Refresh()
        Next
    End Sub
End Class